//---------------------------------------------------------------------------
#include <stdio.h>
#include <stdlib.h>
#include <dir.h>
#include <ctype.h>
#include <limits.h>
#include <string.h>
#include <dirent.h>
//---------------------------------------------------------------------------
#ifndef ERROR_SUCCESS
   #define ERROR_SUCCESS 0
#endif

void error(const char *s);
int ObtenerLargoCodigo(char* nombreArchivo);
int ObtenerNombreDirectorio(char* nombreArchivo,char* nombreDirectorio);
int CrearDirectorio(char* nombreDirectorio,char* ruta);
int MoverArchivos(char* rutaOrigen,char* rutaDestino,char* rutaDestinoErrores);
//---------------------------------------------------------------------------

int main(int argc, char* argv[])
{
    //Cambiar las rutas por las deseadas
    char rutaOrigen[]="C:\\Origen";
    char rutaDestino[]="C:\\Destino";
    char rutaDestinoErrores[]="C:\\Destino\\Errores";

    printf("Directorio raiz de origen: %s\n",rutaOrigen);
    printf("Directorio raiz de destino: %s\n",rutaDestino);
    if(MoverArchivos(rutaOrigen,rutaDestino,rutaDestinoErrores)!=EXIT_SUCCESS)
        printf("Asegurese de que la ruta del directorio es correcta\n");
    system("PAUSE");
    return 0;
}
//---------------------------------------------------------------------------

int MoverArchivos(char* rutaOrigen,char* rutaDestino,char* rutaDestinoErrores)
{
    DIR *dirOrigen,*dirDestino,*dirDestinoErrores;
    struct dirent *ent;
    int retval,nleidos=0,nmovidos=0,ncodigoincorrecto=0;
    int ret;
    char auxRutaOrigen[MAX_PATH],auxRutaDestino[MAX_PATH],auxRutaDestinoErrores[MAX_PATH];
    char nombreDir[MAX_PATH];

    printf("=====================================================\n");
    dirOrigen=opendir(rutaOrigen);
    if(dirOrigen==NULL){
        error("No puedo abrir el directorio de origen");
        retval=EXIT_FAILURE;
    }else{
        dirDestino=opendir(rutaDestino);
        if(dirDestino==NULL){
            error("No puedo abrir el directorio de destino");
            retval=EXIT_FAILURE;
        }else{              
            closedir(dirDestino);
            while((ent=readdir(dirOrigen)) != NULL){
                if((strcmp(ent->d_name,".")!=0)&&(strcmp(ent->d_name,"..")!=0)){
                    ret=ObtenerLargoCodigo(ent->d_name);
                    sprintf(auxRutaOrigen,"%s\\%s",rutaOrigen,ent->d_name);
                    if(ret==8){
                        if(ObtenerNombreDirectorio(ent->d_name,nombreDir)==ERROR_SUCCESS){
                            sprintf(auxRutaDestino,"%s\\%s\\%s",rutaDestino,nombreDir,ent->d_name);
                            if(rename(auxRutaOrigen,auxRutaDestino)==ERROR_SUCCESS){
                                printf("El archivo \"%s\" se movio al directorio \"%s\n",ent->d_name,nombreDir);
                                nmovidos++;
                            }else{
                                 dirDestinoErrores=opendir(rutaDestinoErrores);
                                 if(dirDestinoErrores == NULL){
                                    if(CrearDirectorio("",rutaDestinoErrores)!=ERROR_SUCCESS){
                                       printf("Huvo algun error al crear el directorio de errores\n");
                                       break;
                                    }
                                 }else{
                                    closedir(dirDestinoErrores);
                                 }
                                 sprintf(auxRutaDestinoErrores,"%s\\%s",rutaDestinoErrores,ent->d_name);
                                 if(rename(auxRutaOrigen,auxRutaDestinoErrores)==ERROR_SUCCESS){
                                    printf("No existe el directorio %s. El archivo \"%s\" se movio al directorio \"%s\n",nombreDir,ent->d_name,rutaDestinoErrores);
                                    nmovidos++;
                                 }else{
                                    printf("Huvo algun error al mover el archivo \"%s\" al directorio \"%s\"\n",ent->d_name,rutaDestinoErrores);
                                 }
                            }
                        }
                        nleidos++;
                    }else{
                        dirDestinoErrores=opendir(rutaDestinoErrores);
                        if(dirDestinoErrores == NULL){
                           if(CrearDirectorio("",rutaDestinoErrores)!=ERROR_SUCCESS){
                              printf("Huvo algun error al crear el directorio de errores\n");
                              break;
                           }
                        }else{
                           closedir(dirDestinoErrores);
                        }
                        sprintf(auxRutaDestinoErrores,"%s\\%s",rutaDestinoErrores,ent->d_name);
                        if(rename(auxRutaOrigen,auxRutaDestinoErrores)==ERROR_SUCCESS){
                           printf("Codigo incorrecto. El archivo \"%s\" se movio al directorio \"%s\n",ent->d_name,rutaDestinoErrores);
                           nmovidos++;
                        }else{
                           printf("Huvo algun error al mover el archivo \"%s\" al directorio \"%s\"\n",ent->d_name,rutaDestinoErrores);
                        }
                        ncodigoincorrecto++;
                    }
                }
            }
            printf("=====================================================\n");

            if(nleidos > 0)
                printf("Se han movido %i de %i archivos\n",nmovidos,nleidos+ncodigoincorrecto);
            else if(ncodigoincorrecto==0)
                printf("No se han encontrado archivos\n");
            if(ncodigoincorrecto > 0)
                printf("Se encontraron %i archivos con codigo de cliente incorrectos\n",ncodigoincorrecto);
            retval=EXIT_SUCCESS;
        }
        closedir(dirOrigen);
    }
    return retval;
}
//---------------------------------------------------------------------------

int ObtenerLargoCodigo(char* nombreArchivo)
{
    char *ptr;
    int i,pos,retval=0;

    ptr = strstr(nombreArchivo, "__");
    pos=((int)ptr)-(int)nombreArchivo;
    if(pos==8){
      for(i=0;i<pos;i++){
        if(isdigit(nombreArchivo[i])){
            retval++;
        }else{
            break;
        }
      }
    }
    return retval;
}
//---------------------------------------------------------------------------

int CrearDirectorio(char* nombreDirectorio,char* ruta)
{
   int retval;
   char aux[MAX_PATH]={0};

   sprintf(aux,"%s\\%s",ruta,nombreDirectorio);
   retval=mkdir(aux);
   return retval;
}
//---------------------------------------------------------------------------

int ObtenerNombreDirectorio(char* nombreArchivo,char* nombreDirectorio)
{
    int pos=0,retval;
    char *ptr;

    memset(nombreDirectorio,'\0',MAX_PATH);

    while( (ptr = strstr(&nombreArchivo[pos], "__")) != NULL ){
        pos=((int)ptr+2)-(int)nombreArchivo;
    }
    if(pos >= 2)
        pos-=2;
    strncpy(nombreDirectorio,nombreArchivo,pos);
    if(strlen(nombreDirectorio)>0)
        retval=EXIT_SUCCESS;
    else
        retval=EXIT_FAILURE;
    return retval;
}
//---------------------------------------------------------------------------

void error(const char *s)
{
    /* perror() devuelve la cadena S y el error (en cadena de caracteres) que tenga errno */
    perror(s);
}
//---------------------------------------------------------------------------